//********************************************************
//         File: C:\..\cis421\SetPressure.java
//       Author: HGG 
//         Date: January 2000
//     Computer: PCs and KUNet
//     Compiler: jdk1.1.8 and up
//      Purpose: To demonstrate the need for mutual exclusion
//               The safe pressure is 20, but we can set it 
//               much higher 
//    Reference: Just Java 2
//********************************************************

public class BadPressure 
{
   static int pressureGauge = 0;
   static final int SafetyLimit = 20;

   public static void main(String [] args)
   {
      pressure [] p1 = new pressure[10];
      for(int i = 0; i < 10; i++)
      {
        p1[i] = new pressure();
        p1[i].start();
      } 
      try
      {
      for(int i = 0; i < 10; i++)
         p1[i].join();
      }
      catch (Exception e)
      {} // do nothing 
      System.out.println("Gauge reads " + pressureGauge +
                         ", safe limit is " + SafetyLimit);
   }
}

class pressure extends Thread
{ //static Object obj = new Object();

  // static synchronized  // class exclusion
  void raisePressure()
  {
    //synchronized(obj)
   {
    if(BadPressure.pressureGauge < BadPressure.SafetyLimit - 15)
    {
      try
      {  
        sleep(5000);
      }
      catch(Exception e)
      {}
      BadPressure.pressureGauge += 15;
    }
    else ;  // pressure too high; don't increase it.
   }
  }
  public void run()
  {
    raisePressure();
  }

}
